<?php

/*
 * Copyright (C) 2014, NoccyLabs
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 */

namespace NoccyLabs\Gpio;

use NoccyLabs\Gpio\Exception\HardwareException;

/**
 * Watch GPIO for interrupts (hardware or software)
 *
 *
 *
 */
class GpioWatcher 
{
    protected $fd_gpio = array();
    protected $fd_pins = array();
    
    public function refresh()
    {
        $read = $this->fd_gpio;
        $write = array();
        $except = $read;
        if (count($read)>0) {
            stream_select($read, $write, $except, 0);
            foreach($except as $fd) {
                $pin = $this->getPinFromFd($fd);
                $pin->doInterrupt();
            
            }
        }
    }
    
    public function getPinFromFd($fd)
    {
        foreach($this->fd_pins as $pinfd=>$pin) {
            if ($pinfd == $fd) { return $pin; }
        }
        return false;
    }
    
    public function enableInterrupt(GpioPin $pin, $fd)
    {
        $this->fd_gpio[] = $fd;
        
        $this->fd_pins[$fd] = $pin;
        
    }
    
    public function disableInterrupt(GpioPin $pin)
    {
    }
    
   
}
